/*
 * Copyright 2019 Pawel Szczypkowski
 *
 * This file is part of Concul.
 *
 * Concul is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Concul is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Concul.  If not, see <http://www.gnu.org/licenses/>.
 */





#include <GL/glut.h>  // GLUT, includes glu.h and gl.h
#include<string>
#include<iostream>
#include"crystal.h" 
#include"operations.h"
#include <fstream>

using namespace std;

int main(int argc, char** argv) {

    fstream file;
    file.open("zloto.xyz", ios::out);
    float x= -15;
    float y= -15;
    float z= -15;
    for (int i = 0; i < 11; ++i) {
        x+=3;
        for (int j = 0; j < 11 ; ++j) {
            y+=3;
            for (int k = 0; k < 11 ; ++k) {
                z+=3;
                file<<"Cf   "<<x<< "    "<<y<<" "<<z<<endl;
            }
            z=-15;
        }
        y = -15;
    }

   glutInit(&argc, argv);                 // Initialize GLUT

   window(640, 420);					//makes a window called H20 
   
   glutReshapeFunc(reshape);			//function that changes aspect ratio while window is resized
   //glutSetCursor(GLUT_CURSOR_CROSSHAIR);
   static vector<Atom> allatoms;

   loadfile(& allatoms, "periodictable.xyz");

   static Drawing display = Drawing(allatoms);


   gluLookAt(0,1,1,-10,-10,0,0,1,0);
   glutDisplayFunc(display.draw_everything);			//draws everything needed 
   display.user_interface();

   glutTimerFunc(0, timer, 0);			//you need to wait a bit for the next loop
   initGL();	 						//sets nice view 

   MatrixIdentity(display.RotateMatrix);
   MatrixIdentity(display.InvRotateMatrix);

   glutMainLoop();   					// Enter the infinitely event-processing loop

   return 0;
}

//glutMouseFunc(display.zooming);				//zooming with a scroll wheel
//glutMotionFunc(mouse_motion);		// rotating around upward axis whith mouse (right button must be pressed)
//display.createmenu();

//at1.set_color(0,1,0);
//vector<int> clbondings;
//clbondings.push_back(1);
// allatoms.push_back(Atom(Ag, -0.13,-0.13,0.));
//  sprawko(allatoms);

/*
 vector<int> cbondings;
   cbondings.push_back(0);
   cbondings.push_back(2);
   cbondings.push_back(3);
   cbondings.push_back(4);
    static Atom at2=Atom(C,0.,0.,0.,cbondings);
   at2.set_color(0.3,0.3,0.3);
   allatoms.push_back(at2);

    vector<int> Obondings;
    Obondings.push_back(1);
    vector<int> Hbondings;
    Hbondings.push_back(1);
    vector<int> Fbondings;
    Fbondings.push_back(1);
   static Atom at3=Atom(static_cast<elements>(0),0.13,-0.13,0,Hbondings);
	at3.set_color(1,0,0);
   allatoms.push_back(at3);

   static Atom at4=Atom(O,0.,0.13,0.13,Obondings);
	at4.set_color(0,0,1);
   allatoms.push_back(at4);

   static Atom at5=Atom(F,0.,0.13,-0.13,Fbondings);
	at5.set_color(1,0,0);
   allatoms.push_back(at5);
*/