/*
 * Copyright 2019 Pawel Szczypkowski
 *
 * This file is part of Concul.
 *
 * Concul is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Concul is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Concul.  If not, see <http://www.gnu.org/licenses/>.
 */



#include"operations.h"

#include<cstdlib>
#include<cstdlib>
#include<stdio.h>
#include<iostream>
#include<string>
#include<GL/gl.h>
#include<GL/glut.h>
#include<iomanip>
#include<cmath>
#include<vector>
#include<math.h> 


	bool absolut(float x, float limit){
			
		static float lim;
		static float ix;
		if(limit < 0)
		{
			lim = -limit;
		}
		else{lim = limit;}
		
		if (x < 0)
		{
			ix = -x;
		}
		else{ix = x;}
		if (ix <= lim)
		{
			return true;
		}
		else 
		return false; 
	}

	void MatrixIdentity(float* matrics){
	for(int i=0; i<16; i++)
	{
		if(i == 0 || i== 5 || i==10 || i ==15)
		{
			matrics[i]=1;
		}
		else 
		matrics[i]=0;
	}
 } 
	
	float AbsValue(float x){
	if (x < 0)
	{
		return -x;
	}
	else 
	return x;
	}	

    float Det(float* matr, int i){
	float x=matr[i]*matr[i+5]-matr[i+1]*matr[i+4];
	return x;	
}

	void InversingMatrix(float* matrix1, float* invmatrix){
	MatrixIdentity(invmatrix);
	invmatrix[0]=Det(matrix1, 5);
	invmatrix[1]=-(matrix1[1]*matrix1[10]-matrix1[2]*matrix1[9]);
	invmatrix[2]=Det(matrix1,1);	
	invmatrix[4]=-(matrix1[4]*matrix1[10]-matrix1[8]*matrix1[6]);
	invmatrix[5]=matrix1[0]*matrix1[10]-matrix1[2]*matrix1[8];
	invmatrix[6]=-(matrix1[0]*matrix1[6]-matrix1[4]*matrix1[2]);
	invmatrix[8]=Det(matrix1,4);
	invmatrix[9]=-(matrix1[0]*matrix1[9]-matrix1[1]*matrix1[8]);
	invmatrix[10]=Det(matrix1,0);
	
} 
 
    void timer(int value) {
   glutPostRedisplay();      // Post re-paint request to activate display()
   glutTimerFunc(15, timer, 0); // next timer call milliseconds later
}
	 
    void window(int wl, int ww){
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_DEPTH ); // Enable double buffered mode
   glutInitWindowSize(wl, ww);
   glutInitWindowPosition(50, 50);
   glutCreateWindow("Bear-Evolutionary-Algorithm-Research");
}  

	void initGL(){
	
        glClearColor(191.0/255.0 , 191.0/255.0, 191.0/255.0, 1.0); // Set background color to grey
              // Set background depth to farthest
        glEnable(GL_DEPTH_TEST);

        glDepthFunc( GL_LEQUAL );
   
        glMatrixMode(GL_MODELVIEW);
        glShadeModel(GL_SMOOTH);   // Enable smooth shading
        //glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  // Nice perspective corrections
    }
	
	void reshape(GLsizei width, GLsizei height) {  // GLsizei for non-negative integer
		
   // Compute aspect ratio of the new window
   if (height == 0) height = 1;                // To prevent divide by 0
   GLfloat aspect = (GLfloat)width / (GLfloat)height;
 
   // Set the viewport to cover the new window
   glViewport(0, 0, width, height);
 
   // Set the aspect ratio of the clipping volume to match the viewport
   glMatrixMode(GL_PROJECTION);  // To operate on the Projection matrix
   glLoadIdentity();             // Reset
   // Enable perspective projection with fovy, aspect, zNear and zFar
   gluPerspective(45.0f, aspect,1.5f, 200.0f);
   glMatrixMode(GL_MODELVIEW);
}

	void location(GLfloat far, GLfloat* Matrix, GLfloat camx, GLfloat camy){
		glMatrixMode(GL_MODELVIEW);
		//glLoadIdentity();
		glTranslatef(camx,camy,-far);
		 
		glMultMatrixf(Matrix);
		
		//glRotatef(110, 1,0,0);
		//glRotatef(30,0,0,1);
		//glRotatef(90, 1,0,0);
}

	void drawarrow(){
	glBegin(GL_LINES);
	 glLineWidth(1.3);
	 glVertex3f(0,0,0);
	 glVertex3f(0.1,0,0);
	glEnd();

	glPushMatrix();
	
	 for(int i=0; i<1800; i++)
	 { 	
	  	glBegin(GL_TRIANGLES);
	   /*cone */
	  	 glVertex3f(0.1,0,0); //upper vertex
		 glVertex3f(0.07,-0.01,0);
		 glVertex3f(0.07,0.01,0);
		glEnd(); 
		 glRotatef(0.1, 1,0,0);
	}
	glPopMatrix();
 }
	
	void grid(){
				
		for(int i=1; i<=9; i++)
		{
				glBegin(GL_LINES);
				 glColor3f(1,1,1);		//white color
				 glLineWidth(1);
				 glVertex3f(0.5-0.1*i, -0.5, 0.0);
				 glVertex3f(0.5-0.1*i, 0.5, 0.0);
				glEnd();
		}
		for(int j=1; j<=9; j++)
		{
		   glBegin(GL_LINES);
			glColor3f(1,1,1);
			glLineWidth(1);
			glVertex3f(0.5, 0.5-0.1*j, 0);
			glVertex3f(-0.5, 0.5-0.1*j, 0);
		   glEnd();
	   }
}	
	
	void light(){
		
		glEnable( GL_LIGHT0 );
		//glLightfv(GL_LIGHT0,
	}
	
	using namespace std;
	
    float x_prim(float x, float y, float z, float *matrix){
		return matrix[0]*x+matrix[1]*y+matrix[2]*z;
}
		
	float y_prim(float x, float y, float z, float *matrix){
		return matrix[4]*x+matrix[5]*y+matrix[6]*z;
}
	
	float z_prim(float x, float y, float z, float *matrix){	
		float a = matrix[8]*x+matrix[9]*y+matrix[10]*z;
		return a;
}

	float x_angle(float x,float y,float z, float far){
		return 180*atan(x/(far-z))/M_PI;
}
	float y_angle(float x,float y,float z, float far){
		return 180*atan(y/(sqrt(pow(x,2)+pow(far-z,2))))/M_PI;
}	
	double theta(double x, double y, double z){
		if(z == 0)
		{
			return 90;
		}
		double theta = acos(z/sqrt(z*z+x*x+y*y))*180./M_PI;
		return theta;
	}
	double phi(double x,double y, double z){
		double phi;
		double param = x/sqrt(z*z+x*x+y*y);
		phi = acos(param)*180./3.14;
		if(y == 0 && x > 0){
			return 0;
		}else if(y == 0 && x< 0)
		{
			return 180;
		}else if(x == 0 && y > 0){
			return 90;
		}else if(x == 0 && y< 0)
		{
			return -90;
		}else
		{
	
		if(y > 0)
		{
			return phi;
		}else
		{
			return -phi;
		}
	}
	
	}


		
	
	
	
	
	
	
	

