/*
 * Copyright 2019 Pawel Szczypkowski
 *
 * This file is part of Concul.
 *
 * Concul is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Concul is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Concul.  If not, see <http://www.gnu.org/licenses/>.
 */




#ifndef operations_h_
#define operations_h_

#include<cstdlib>
#include<cstdlib>
#include<stdio.h>
#include<iostream>
#include<string>
#include<GL/gl.h>
#include<GL/glut.h>
#include<iomanip>
#include<cmath>
#include<vector>
#include<math.h> 
/*This Header File is just a set of additional functions*/

bool absolut(float x, float limit);	
void MatrixIdentity(float* matrics); 
float AbsValue(float x);
void InversingMatrix(float* matrix1, float* invmatrix);
float Det(float* matr, int pocz);
double theta(double x, double y, double z);
double phi(double x,double y, double z);


/*Basic Functions*/ 
void window(int wl, int ww); 						//creates window of wanted size (wl , ww) named H2O
void timer(int value);								//calls function to redraw everything (needed, when sth should move) 
void reshape(GLsizei width, GLsizei height);		//when window is resized it also resizes the image 
void initGL();										//initialization, nice view and sth doesnot work here (back buffer)

/* location */
void location(GLfloat far, float* Matrix, GLfloat camx, GLfloat camy);  					//locates whole drawed scene

/*basic drawing functions */

void drawarrow();									//draws line with a cone at the one's end
void axis(float* Matrix, GLfloat camx, GLfloat camy);										// draw coordinate axis
void grid(); 										//draws grid with

/*lightning*/
void light();

/*for letters drawing*/
float x_prim(float x, float y, float z, float *matrix);
float y_prim(float x, float y, float z, float *matrix);
float z_prim(float x, float y, float z, float *matrix);
float x_angle(float x,float y,float z, float far);
float y_angle(float x,float y,float z, float far);


#endif
